#include "system.h"
#include "plot.h"
#include<fstream>

int main (int argc, char *argv[])
{
  string fname;
  if (argc >= 2)
    fname = argv[1];
  else {
    cerr << "Enter filename: ";
    cin >> fname;
  }
  ifstream istr(fname.c_str());
  if (!istr.good()) return 0;
  System s;
  s.read(istr);
  Motions motions;
  Trajectory traj;
  double c0[100], pb[6];
  s.read_motions(istr, motions, c0, pb);
  s.simulate(c0, motions, traj);
  s.form_pair_trajectories(traj);
  graphics_init(argc, argv, 500, s, traj, pb, false);
  return 0;
}
