#ifndef PLOT
#define PLOT

#include <GL/glut.h>

void copy_bbox (double *b, double *c);

class SystemWindow {
public:
  SystemWindow (int iw, int ih, int iid, double *ibbox, int inpair = -1)
    : w(iw), h(ih), id(iid), npair(inpair)
  { copy_bbox(ibbox, bbox); copy_bbox(ibbox, bboxz); }

  int w, h, id;
  double bbox[6], bboxz[6];
  int npair;
};

typedef vector<SystemWindow> SystemWindows;

void graphics_init (int argc, char **argv, int wsize, System &s, Trajectory &t,
		    double *b, bool v);

string cspace_window_name (Pair *pair);

SystemWindow & get_window ();

void reshape (int w, int h);

void keyboard (unsigned char key, int x, int y);

void postscript_window ();

void mouse (int button, int buttonState, int x, int y);

Point point (int x, int y);

void mouse_zoom (int buttonState, const Point &p);

void mouse_config (const Point &p);

void mouse_path (const Point &p);

void motion (int x, int y);

void menu_init ();

void menu (int value);

void display ();

void trajectory_step (double dt);

void display_cspace (SystemWindow &w);

void draw_polyline (const Points &points);

void draw_point (const Point &p);

void display_system (double *bbox);

void display_zoom ();

void draw_system (System *s, double *c, bool fill);

void draw_path (System *system, const Points &path);

void draw_part (Part *part, double *c, bool fill);

void draw_cspace (const Pair &pair, double *bbox);

void set_scale (double x1, double x2, double y1, double y2,
		double z1, double z2);

void clear_screen (float *color);

void draw_axes (const double *xr, const double *yr, float *color);

void draw_regions (const glRegions &regions, float *color, bool fill);

void draw_region (const glRegion &r, float *color, bool fill);

#endif
