#ifndef POSTSCRIPT
#define POSTSCRIPT

#include "system.h"

class PsView {
 public:
  PsView () : w(0), h(0), ostr(0) {}
  PsView (int iw, int ih, double *bbox, ostream *iostr);
  Point scale (const Point &p) const;
  void open () const;
  void close () const;
  void polygon (const Points &points, double width, float *color, 
		bool close, bool fill) const;
  void setprops (double width, float *color, string action) const;
  void arrow (double x1, double y1, double x2, double y2,
	      double width, float *color, int length = 5) const;
  void bullet (const Point &p, int r, float *color) const;
  void draw_system (System *s, double *c, double width, bool fill, double acc) const;
  void draw_part (Part *part, double *c, double width, bool fill, double acc) const;
  void draw_profile_filled (const Profile &profile, double width, 
			    float *color) const;
  void draw_profile (const Profile &profile, double width, float *color) const;
  void draw_triangles (const Triangles &triangles, float *color) const;
  void draw_cspace (System *sys, Pair *pair, double *c, Trajectory *traj, 
		    double *bbox, bool czone) const;
  void draw_regions (Regions *regions, double width, float *color) const;
  void draw_axes (double *bbox, double width, float *color) const;
  void draw_trajectory (Trajectory *traj, int np, int ia, int ib,
			double width, float *color) const;

  int w, h;
  double xs, xb, ys, yb;
  ostream *ostr;
};


#endif
